unit UniDefs;

{
   UniDefs.pas Copyright (C) 1999, 2000 David Mason

   This code is freeware:

        - It may be used by anyone, private or commercial.
        - It may be freely distributed without modification.

        - Do not modify and redistribute without checking
          with the author.
        - Do not remove this notice.
        - If you find it useful, please email me:
          drmason@xtra.co.nz
        - If this component is used in a program that
          makes you lots of money, please consider
          donating some to the author.


   THIS CODE IS PROVIDED AS IS, WITH NO GUARANTEES.
   USE THIS CODE AT YOUR OWN RISK. THE AUTHOR WILL
   NOT BE HELD RESPONSIBLE FOR ANY DAMAGE CAUSED BY
   THIS CODE.
}

interface

type
  TCodePage=(cpThai,
             cpJapan,
             cpChineseSimplified,
             cpKorean,
             cpChineseTraditional,
             cpUnicode,
             cpEastEuropean,
             cpCyrillic,
             cpANSI,
             cpGreek,
             cpTurkish,
             cpHebrew,
             cpArabic,
             cpBaltic,
             cpKoreanJohab);

const CodePageIdentifiers:array[cpThai..cpKoreanJohab] of word
        =(874,	// Thai
          932,	// Japan
          936,	// Chinese (PRC, Singapore)
          949,	// Korean
          950,	// Chinese (Taiwan, Hong Kong)
          1200,	// Unicode (BMP of ISO 10646)
          1250,	// Windows 3.1 Eastern European
          1251,	// Windows 3.1 Cyrillic
          1252,	// Windows 3.1 US (ANSI)
          1253,	// Windows 3.1 Greek
          1254,	// Windows 3.1 Turkish
          1255,	// Hebrew
          1256,	// Arabic
          1257,	// Baltic
          1361	// Korean (Johab)
          );

procedure ConvertToUNICODE(CodePage:TCodePage;s:string;
                            var w:PWideChar); overload;
procedure ConvertToUNICODE(CodePageID:word;s:string;
                            var w:PWideChar); overload;


implementation

uses Windows;

procedure ConvertToUNICODE(CodePage:TCodePage; s:string; var w:PWideChar);
begin
  ConvertToUNICODE(CodePageIdentifiers[CodePage],s,w);
end;

procedure ConvertToUNICODE(CodePageID:word;s:string; var w:PWideChar);
var wlen:word;
begin
  // Allocate the space for the output string
  // 2 bytes for every char in s, and the zero terminator word
  wlen:=2*Length(s)+2;
  ReallocMem(w,wlen);

  // Unterminated strings sometimes come out of MultiByteToWideChar
  // so it is necessary to zero the buffer first
  ZeroMemory(w,wlen);

  MultiByteToWideChar(CodePageID,
                      0,
                      PChar(s),
                      Length(s),
                      W,
                      wlen);
end;

end.
